; Written by Coyan of the Mosaic Guild
;
helptxt =
( The hotkeys are as follows

 Cntl-F1 - this requests and stores info like Memory Game level, Pull Delay and Number of pulls

 F1 - each time you hit F1 it will mark a crystal, up to 7 crystals. After 7 crystals have been marked, it will tell you to hit F2 or Cntl-F2.

 F2 - will run the mine as many times as you have defined in the initial information.

 Cntl-F2 - This will run the mine once. So if you want to manually pull it, but don't want to deal with the crystal choices, this is an option.

Cntl-q - pauses and un-pauses the macro.

 Cntl-x - This will exit hotkeys and this application.

 Cntl-h - this is the help dialog
)
MemLevel := 1
PullDelay := 5500
Numopulls := 1000
MenuX := 15
MenuY := -7
CONSTVAL := 100/255
ColorS := 0
ColorN := 0
CRC := 0
color := ""
Mousecnt := 1
Cryscnt := 1

^F1::
	Gui, Add, Text,, Memory Level(1-7):
	Gui, Add, Text,, Pull Delay(miliseconds):
	Gui, Add, Text,, Number of Pulls:
	Gui, Add, Edit, vMemLevel ym Number Limit1,6 ; The ym option starts a new column of controls.
	Gui, Add, Edit, vPullDelay Number,5500
	Gui, Add, Edit, vNumoPulls Number,1000
	Gui, Add, Button, default, OK  ; The label ButtonOK (if it exists) will be run when the button is pressed.
	Gui, Show,, Silver Mining
	return  ; End of auto-execute section. The script is idle until the user does something.

	GuiClose:
	ButtonOK:
	Gui, Submit  ; Save the input from the user to each control's associated variable.
return

F1::
	if Cryscnt <=7
	{
		MouseGetPos, MouseX, MouseY
		MX%CrysCnt% := MouseX
		MY%CrysCnt% := MouseY
		Send Marked %Cryscnt% {Enter}
		Cryscnt += 1
	}
	ELSE
	{
		Send All crystals have been marked, please hit F2 to loop or Cntl-F2 for once. {Enter}
	}
return

^F2::
	Loop 7
	{
		MSX := MX%A_Index%
		MSY := MY%A_Index%

		PixelGetColor, color, %MSX%, %MSY%

		CrysColor%A_Index% := color
		CRC := color

		GoSub, CALCSATCOLOR

		CrysColor%A_Index% := ColorN

		IF ColorN > %ColorS%
		{
			ColorS := ColorN
			Mousecnt := A_Index
		}
		Sleep 100

	}

	Loop 7
	{
		currcolor := CrysColor%A_Index%
		If currcolor < %ColorS%
		{
			IF currcolor > %ColorS2%
			{
				ColorS2 := CrysColor%A_Index%
				Mousecnt := A_Index
			}
		}
	}

	MeLRv := MemLevel
	Loop %MemLevel%
	{
		MeLRvP := MeLRv - 1

		IF A_Index < %MemLevel%
		{
			IF MEpt%MeLRvP%
			{
				MEpt%MeLRv% := MEpt%MeLRvP%
			}
			ELSE
			{
				MEpt%MeLRv% := Mousecnt
			}
		}
		ELSE
		{
			MEpt%MeLRv% := Mousecnt
		}

		MeLRv -= 1
	}
	Mousecnt := MEpt%MemLevel%

	MSX := MX%Mousecnt%
	MSY := MY%Mousecnt%

	Sleep 200
	Click %MSX%, %MSY%
	MSX += MenuX
	MSY += MenuY
	Sleep 200
	Click %MSX%, %MSY%

	ColorN := 0
	ColorS := 0
	ColorS2 := 0

return

F2::
	Loop %Numopulls%
	{
		Send ^{F2}

		Sleep PullDelay
	}
return

^x::
	ExitApp
return

^q::
	Pause toggle
return

^h::
	MsgBox, %helptxt%
return
CALCSATCOLOR:  ; This procedure calculates the saturation of the crystal
	Minval := 0
	Maxval := 255

	RGBBlue := hextodec(SubStr(CRC, 1, 4))

	RGBGreen := hextodec(SubStr(CRC, 1, 2) . SubStr(CRC, 5, 2))

	RGBRed := hextodec(SubStr(CRC, 1, 2) . SubStr(CRC, 7, 2))

	IF RGBRed > %RGBGreen%
	{
		Minval := RGBGreen
		Maxval := RGBRed
	}
	Else
	{
		Maxval := RGBGreen
		Minval := RGBRed
	}

	IF RGBBlue < %Minval%
	{
		Minval := RGBBlue
	}
	ELSE
	{
		IF RGBBlue > %Maxval%
		{
			Maxval := RGBBlue
		}
	}

	ColorN := ((Maxval - Minval) / Maxval) * (100.0/255.0)
RETURN

hextodec(hexvalue)
{
	SetFormat, integer, d
	hexvalue += 0
	;SetFormat, integer, hex
	return hexvalue
}